(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "@tsparticles/engine", "./SimplexNoiseGenerator.js"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.simplexNoisePathName = void 0;
    exports.loadSimplexNoisePath = loadSimplexNoisePath;
    const engine_1 = require("@tsparticles/engine");
    const SimplexNoiseGenerator_js_1 = require("./SimplexNoiseGenerator.js");
    exports.simplexNoisePathName = "simplexNoise";
    async function loadSimplexNoisePath(engine, refresh = true) {
        (0, engine_1.assertValidVersion)(engine, "3.7.1");
        await engine.addPathGenerator(exports.simplexNoisePathName, new SimplexNoiseGenerator_js_1.SimplexNoiseGenerator(), refresh);
    }
});
